<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Doashboard</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="../plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />

  <link rel="stylesheet" href="../plugins/daterangepicker/daterangepicker.css">
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">

  <!-- SweetAlert2 -->
  <link rel="stylesheet" href="../plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
  <!-- Toastr -->
  <link rel="stylesheet" href="../plugins/toastr/toastr.min.css">

  <!-- Theme style -->
  <link rel="stylesheet" href="../dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../index.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../contact.html" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>


        <li class="nav-item">
          <a class="nav-link btn-log-out" role="button">
            <i class="fas fa-sign-out-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <!-- Brand Logo -->
      <a href="dashboard.html" class="brand-link">
        <img src="../dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Moomap Admin</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="../dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Alexander Pierce</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-th"></i>
                <p>
                  Manage
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="dashboard.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="customer.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Customer</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="order.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product-line.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Product Line</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Product</p>
                  </a>
                </li>

                <li class="nav-item">
                  <a href="rating.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Rating</p>
                  </a>
                </li>

                <li class="nav-item user-manager">
                  <a href="user.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>User</p>
                  </a>
                </li>

              </ul>
            </li>
            <!--  -->
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Dashboard</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Dashboard</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <!-- Small boxes (Stat box) -->
          <div class="row">
            <div class="col-lg-3 col-6">
              <!-- small box -->
              <div class="small-box bg-info">
                <div class="inner">
                  <h3 id="h3-number-orders"></h3>

                  <p>Đơn hàng</p>
                </div>
                <div class="icon">
                  <i class="ion ion-bag"></i>
                </div>
                <a href="order.html" class="small-box-footer">Xem thêm <i class="fas fa-arrow-circle-right"></i></a>
              </div>
            </div>
            <!-- ./col -->
            <div class="col-lg-3 col-6">
              <!-- small box -->
              <div class="small-box bg-success">
                <div class="inner">
                  <h3 id="h3-total-payment"></h3>

                  <p>Doanh thu</p>
                </div>
                <div class="icon">
                  <i class="ion ion-stats-bars"></i>
                </div>
                <a href="order.html" class="small-box-footer">Xem thêm <i class="fas fa-arrow-circle-right"></i></a>
              </div>
            </div>
            <div class="col-lg-3 col-6">
              <!-- small box -->
              <div class="small-box bg-warning">
                <div class="inner">
                  <h3 id="h3-total-customer"></h3>

                  <p>Khách hàng</p>
                </div>
                <div class="icon">
                  <i class="ion ion-person-add"></i>
                </div>
                <a href="customer.html" class="small-box-footer">Xem thêm <i class="fas fa-arrow-circle-right"></i></a>
              </div>
            </div>
            <!-- ./col -->
            <div class="col-lg-3 col-6">
              <!-- small box -->
              <div class="small-box bg-danger">
                <div class="inner">
                  <h3>65</h3>

                  <p>Người đăng ký</p>
                </div>
                <div class="icon">
                  <i class="ion ion-pie-graph"></i>
                </div>
                <a href="#" class="small-box-footer">Xem thêm <i class="fas fa-arrow-circle-right"></i></a>
              </div>
            </div>
            <!-- ./col -->
            <!-- ./col -->
          </div>
          <div class="row">
            <div class="col-sm-6">
              <div class="card">
                <div class="card-header border-0">
                  <div class="d-flex justify-content-between">
                    <h3 class="card-title">Đơn hàng</h3>
                    <select name="" id="select-type-report" class="form-control w-25">
                      <option value="day">Theo ngày</option>
                      <option value="week">Theo tuần</option>
                      <option value="month">Theo tháng</option>
                    </select>
                  </div>
                </div>
                <div class="card-body">
                  <div class="d-flex">
                    <p class="d-flex flex-column">
                      <span>Tổng doanh thu</span>
                      <span id="span-total-ammount" class="text-bold text-lg"></span>
                    </p>
                    <!-- <p class="ml-auto d-flex flex-column text-right">
                      <span class="text-success">
                        <i class="fas fa-arrow-up"></i> 33.1%
                      </span>
                      <span class="text-muted">Since last month</span>
                    </p> -->
                  </div>
                  <!-- /.d-flex -->

                  <div class="position-relative mb-4">
                    <canvas id="orders-chart" height="200"></canvas>
                  </div>

                  <div class="d-flex flex-row justify-content-end">
                    <button id="btn-export" class="btn btn-secondary">Export Excel</button>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-sm-6">
              <div class="card">
                <div class="card-header border-0">
                  <div class="d-flex justify-content-between">
                    <h3 class="card-title">Khách hàng</h3>
                    <select name="" id="select-type-sort-customer-rank" class="form-control w-25">
                      <option value="rank-1">Hạng từ thấp đến cao</option>
                      <option value="rank-2">Hạng từ cao đến thấp</option>
                    </select>
                  </div>
                </div>
                <div class="card-body">
                  <div class="d-flex">
                    <p class="d-flex flex-column">
                      <span>Tổng khách hàng</span>
                      <span id="span-total-customer" class="text-bold text-lg"></span>
                    </p>
                    <!-- <p class="ml-auto d-flex flex-column text-right">
                      <span class="text-success">
                        <i class="fas fa-arrow-up"></i> 33.1%
                      </span>
                      <span class="text-muted">Since last month</span>
                    </p> -->
                  </div>
                  <!-- /.d-flex -->

                  <div class="position-relative mb-4">
                    <canvas id="customers-chart" height="200"></canvas>
                  </div>

                  <div class="d-flex flex-row justify-content-end">
                    <select name="select-rank-export" id="select-rank-export" class="form-control w-50 mr-2" >
                      <option value="all">Tất cả hạng</option>
                      <option value="plantinum">Bạch kim</option>
                      <option value="gold">Vàng</option>
                      <option value="silver">Bạc</option>
                      <option value="vip">Vip</option>
                    </select>
                    <button id="btn-export-customers" class="btn btn-secondary">Export Excel</button>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <div class="card export-box border-0 p-4">
            <div class="row">

              <div class="col-sm-12 text-center">
                <h5>Xuất danh sách đơn hàng theo khoảng thời gian</h5>

              </div>
              <div class="col-sm-4 text-right">
                <label for="">Chọn thời gian</label>

              </div>
              <div class="col-sm-4">
                <div class="input-group mb-2">
                  <div class="input-group-prepend">
                    <span class="input-group-text">
                      <i class="far fa-calendar-alt"></i>
                    </span>
                  </div>
                  <input type="text" class="form-control float-right" id="reservation">
                  <!-- /.input group -->
                </div>
              </div>
              <div class="col-sm-4">
                <button id="btn-export-range" class="btn btn-success">Xuất</button>
              </div>
            </div>
          </div>

        </div><!-- /.container-fluid -->
      </section>
      <!-- /.content -->
      <!-- /.content-wrapper -->
    </div>

     <!-- Modal log out-->
  <div class="modal fade" id="modal-log-out">
    <div class="modal-dialog modal-sm">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title text-dark">Đăng xuất <i class="fas fa-lock"></i></h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <h6>Bạn có thực sự muốn đăng xuất?</h6>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-warning" id="btn-confirm-log-out">
            Đăng xuất
          </button>
          <button type="button" class="btn btn-secondary" data-dismiss="modal">
            Hủy bỏ
          </button>
        </div>
      </div>
    </div>
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="../plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="../plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="../plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="../plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <script src="../plugins/moment/moment.min.js"></script>
  <script src="../plugins/inputmask/jquery.inputmask.min.js"></script>
  <script src="../plugins/daterangepicker/daterangepicker.js"></script>

  <!-- OPTIONAL SCRIPTS -->
  <script src="../plugins/chart.js/Chart.min.js"></script>
  <!-- AdminLTE App -->
  <script src="../dist/js/adminlte.js"></script>



</body>
<!-- File js -->
<script src="../js/action.js"></script>
<script>//Date range picker
  $('#reservation').daterangepicker();
  $('#reservation').val("")
  $('#reservation').prop("placeholder", "Chọn khoảng thời gian");
</script>

<!-- SweetAlert2 -->
<script src="../plugins/sweetalert2/sweetalert2.min.js"></script>
<!-- Toastr -->
<script src="../plugins/toastr/toastr.min.js"></script>
<script>

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gStartDate = null;
  var gEndDate = null;
  const gBASE_URL_REPORT = "http://localhost:8080/orders/report/";
  const gBASE = "http://localhost:8080/orders/";
  const gBASE_CUSTOMER = "http://localhost:8080/customers/";
  const gBASE_URL ="http://localhost:8080/";
  const gTOKEN = getCookie("token");

  // Hiển thị thông báo
  var gToast = Swal.mixin({
    toast: true,
    position: 'top-end',
    showConfirmButton: false,
    timer: 3000
  });

  // Format tiền tệ VNĐ
  const VND = new Intl.NumberFormat('vi-VN', {
    style: 'currency',
    currency: 'VND',
  });

  var gOrdersChart = $('#orders-chart');
  var vOrdersChart = new Chart(gOrdersChart, {
    type: 'bar',
    data: {
      labels: ['', '', '', '', '', '', ''],
      datasets: [
        {
          backgroundColor: '#007bff',
          borderColor: '#007bff',
          data: []
        }
      ]
    },
    options: {
      maintainAspectRatio: false,
      tooltips: {
        mode: 'index',
        intersect: false,
        callbacks: {
          label: function (tooltipItem, data) {
            var value = data.datasets[tooltipItem.datasetIndex].data[tooltipItem.index];
            return value.toLocaleString('vi-VN', { style: 'currency', currency: 'VND' }).replace(/\D/g, '');
          }
        }
      },
      hover: {
        mode: 'index',
        intersect: false
      },
      legend: {
        display: false
      },
      scales: {
        y: {
          grid: {
            display: true,
            lineWidth: '4px',
            color: 'rgba(0, 0, 0, .2)',
            zeroLineColor: 'transparent'
          },
          ticks: {
            beginAtZero: true,
            callback: function (value) {
              if (value >= 1000) {
                value /= 1000;
                value += 'k';
              }
              return value.toLocaleString('vi-VN', { style: 'currency', currency: 'VND' }).replace(/\D/g, '');
            }
          }
        },
        x: {
          display: true,
          grid: {
            display: false
          }
        }
      }
    }
  });

  var gCustomerChart = $("#customers-chart");
  var vCustomerChart = new Chart(gCustomerChart, {
    type: 'bar',
    data: {
      labels: ['', '', '', '', '', '', ''],
      datasets: [
        {
          backgroundColor: '#007bff',
          borderColor: '#007bff',
          data: []
        }
      ]
    },
    options: {
      maintainAspectRatio: false,
      tooltips: {
        mode: 'index',
        intersect: false,
        callbacks: {
          label: function (tooltipItem, data) {
            var value = data.datasets[tooltipItem.datasetIndex].data[tooltipItem.index];
            return value.toLocaleString('vi-VN', { style: 'currency', currency: 'VND' }).replace(/\D/g, '');
          }
        }
      },
      hover: {
        mode: 'index',
        intersect: false
      },
      legend: {
        display: false
      },
      scales: {
        y: {
          grid: {
            display: true,
            lineWidth: '4px',
            color: 'rgba(0, 0, 0, .2)',
            zeroLineColor: 'transparent'
          },
          ticks: {
            beginAtZero: true,
            callback: function (value) {
              if (value >= 1000) {
                value /= 1000;
                value += 'k';
              }
              return value.toLocaleString('vi-VN', { style: 'currency', currency: 'VND' }).replace(/\D/g, '');
            }
          }
        },
        x: {
          display: true,
          grid: {
            display: false
          }
        }
      }
    }
  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  onPageLoading();
  $("#select-type-report").on("change", function () {
    let vSelectTypeValue = $(this).val();
    if (vSelectTypeValue == "day") {
      callApiToGetOrderReportByDay();
    }
    else if (vSelectTypeValue == "week") {
      callApiToGetOrderReportByWeek();
    }
    else {
      callApiToGetOrderReportByMonth();
    }
  });


  // Thực thi sự kiện nhấn nút export đơn hàng
  $("#btn-export-range").on("click", function () {
    onBtnExportRangeClick();
  });

  // Thực thi sự kiện nhấn nút export theo biểu đồ
  $("#btn-export").on("click", function () {
    callApiToExportData(gStartDate, gEndDate);
  })

  // Thực thi sự kiện thay đổi kiểu sắp xếp biểu đồ khách hàng
  $("#select-type-sort-customer-rank").on("change", function() {
    let vTypeSort = $(this).val();
    callApiToGetCustomerRankReport(vTypeSort);
  })

  // Thực thi sự kiện xuất ra danh sách khách hàng
  $("#btn-export-customers").on("click", function() {
    let vRankValue = $("#select-rank-export").val();
    callApiToExportDataCustomerByRank(vRankValue);
  }); 

  // Thực thi sự kiện nhấn nút logout
  $(".btn-log-out").on("click", function() {
    $("#modal-log-out").modal("show");
  });

   // Thực thi sự kiện nhấn nút đăng xuất
   $("#btn-confirm-log-out").on("click", function () {
    setCookie("token", "", 1);
    window.location.href = "../login.html";
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    // Gọi api lấy tổng thanh toán và số đơn hàng
    if (gTOKEN) {
      callApiToHelloAndAuthenAdminPage();
    }
    else {
      window.location.href = "../login.html";
    }
    callApiToGetTotalPaymentAndNumberOrder();
    // Gọi APi để lấy thông tin biểu đồ đơn hàng theo ngày
    callApiToGetOrderReportByDay();
    // Gọi API để lấy biểu đồ xếp hạng khách hàng
    let vTypeSort = $("#select-type-sort-customer-rank").val();
    callApiToGetCustomerRankReport(vTypeSort);

  }

  // Hàm xử lý sự kiện nhấn nút export range
  function onBtnExportRangeClick() {
    let vInputRangeValue = $("#reservation").val();
    if (vInputRangeValue == "") {
      alertWarning("Vui lòng chọn khoảng thời gian cần xuất dữ liệu")
      return false;
    }
    let vDateArray = vInputRangeValue.split(" - ");
    // Dùng hàm format date để chuyển từ dạng mặc định mm/dd/yyyy sang dạng yyyy-mm-dd
    let vStartDate = formatDate(vDateArray[0]);
    let vEndDate = formatDate(vDateArray[1]);
    callApiToExportData(vStartDate, vEndDate);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/


  // Hàm cập nhật dữ liệu cho biểu đồ
  function updateChartDay(paramChartData) {
    let vTimeArray = paramChartData.map(item => convertDateFormat(item[0]));
    let vTimeStartPart = vTimeArray[0].split("-");
    gStartDate = vTimeStartPart[2] + "-" + vTimeStartPart[1] + "-" + vTimeStartPart[0];
    gEndDate = getCurrentDate();
    let vNumberOrdersArray = paramChartData.map(item => item[1]);
    updateTotalAmmount(vNumberOrdersArray);
    vOrdersChart.data.labels = vTimeArray;
    vOrdersChart.data.datasets[0].data = vNumberOrdersArray;
    vOrdersChart.update();
  }

  // Update chart khi báo cáo theo tuần
  function updateChartWeek(paramChartData) {
    let vTimeArray = paramChartData.map(item => convertWeekToDate(item[0]));
    let vNumberOrdersArray = paramChartData.map(item => item[2]);
    // Theo tuần thì sẽ có dạng từ ngày ..  đến ngày thì sẽ dùng hàm split để lấy riêng ngày đầu của tuần đầu ra và ngày cuối của tuần cuối
    let vFirstWeekDate = vTimeArray[0].split(" đến ");

    gEndDate = getCurrentDate();
    gStartDate = vFirstWeekDate[0] + "-" + getCurrentYear();
    if (gStartDate > gEndDate) {
      gStartDate = vFirstWeekDate[0] + "-" + (getCurrentYear - 1);
    }
    updateTotalAmmount(vNumberOrdersArray);
    vOrdersChart.data.labels = vTimeArray;
    vOrdersChart.data.datasets[0].data = vNumberOrdersArray;
    vOrdersChart.update();
  }

  // Update chart khi báo cáo theo tuần
  function updateChartMonth(paramChartData) {
    let vTimeArray = paramChartData.map(item => item[0]);
    gStartDate = vTimeArray[0] + "-01";

    gEndDate = getCurrentDate();
    let vNumberOrdersArray = paramChartData.map(item => item[1]);
    updateTotalAmmount(vNumberOrdersArray);
    vOrdersChart.data.labels = vTimeArray;
    vOrdersChart.data.datasets[0].data = vNumberOrdersArray;
    vOrdersChart.update();
  }






  // Hàm gọi API để lấy ra báo cáo theo ngày
  function callApiToGetOrderReportByDay() {
    let vHeaders = {
      Authorization: "Token " + gTOKEN
    }

    $.ajax({
      type: "GET",
      url: gBASE_URL_REPORT + "day",
      headers: vHeaders,
      async: false,
      success: function (paramRes) {
        updateChartDay(paramRes);
      },
      error: function (paramError) {
        console.log(paramError.status);
      }
    });
  }

  // Hàm gọi API để lấy ra báo cáo theo tuần
  function callApiToGetOrderReportByWeek() {
    let vHeaders = {
      Authorization: "Token " + gTOKEN
    }
    $.ajax({
      type: "GET",
      url: gBASE_URL_REPORT + "week",
      headers: vHeaders,
      async: false,
      success: function (paramRes) {
        updateChartWeek(paramRes);
      },
      error: function (paramError) {
        console.log(paramError.status);
      }
    });
  }

  // Hàm gọi API để lấy ra báo cáo theo tháng
  function callApiToGetOrderReportByMonth() {
    let vHeaders = {
      Authorization: "Token " + gTOKEN
    }
    $.ajax({
      type: "GET",
      url: gBASE_URL_REPORT + "month",
      headers: vHeaders,
      async: false,
      success: function (paramRes) {
        updateChartMonth(paramRes);
      },
      error: function (paramError) {
        console.log(paramError.status);
      }
    });
  }

  // Hàm chuyển tuần trong năm sang ngày
  function convertWeekToDate(week) {
    const year = parseInt(week.slice(0, 4));
    const weekNumber = parseInt(week.slice(6));

    // Create a new date object for the first day of the year
    const date = new Date(year, 0, 1);

    // Get the first day of the week by adding the required number of days
    const firstDayOfWeek = date.getDate() + (weekNumber - 1) * 7;
    date.setDate(firstDayOfWeek);

    // Calculate the last day of the week by adding six days
    const lastDayOfWeek = new Date(date.getFullYear(), date.getMonth(), date.getDate() + 6);

    // Format the start and end dates to display in the "dd-mm" format
    const startDateFormatted = `${date.getDate().toString().padStart(2, '0')}-${(date.getMonth() + 1).toString().padStart(2, '0')}`;
    const endDateFormatted = `${lastDayOfWeek.getDate().toString().padStart(2, '0')}-${(lastDayOfWeek.getMonth() + 1).toString().padStart(2, '0')}`;

    return startDateFormatted + " đến " + endDateFormatted;
  }

  // Hàm thay đổi kiểu dữ liệu ngày
  function convertDateFormat(dateString) {
    const parts = dateString.split("-");
    const year = parts[0];
    const month = parts[1];
    const day = parts[2];
    return `${day}-${month}-${year}`;
  }

  // Thay đổi dữ liệu năm
  function convertYearFormat(paramYear) {
    let vParts = paramYear.split("-");
    let vYear = vParts[0];
    let vMonth = vParts[1];
    return vMonth + "-" + vYear;
  }
  // Hàm update doanh thu cho báo cáo
  function updateTotalAmmount(paramArrayAmmount) {
    let vSpanTotalAmount = $("#span-total-ammount");
    let vTotalAmmount = 0;
    $.each(paramArrayAmmount, function (index, value) {
      vTotalAmmount += value;
    });
    vSpanTotalAmount.html(VND.format(vTotalAmmount));
  }

  // Hàm gọi APi để xuất ra đơn hàng theo khoảng thời gian
  function callApiToExportData(paramStartDate, paramEndDate) {
    var url =  gBASE + 'export?start=' + encodeURIComponent(paramStartDate) + '&end=' + encodeURIComponent(paramEndDate);

    $.ajax({
    url: url,
    method: 'GET',
    headers: {
      'Authorization': 'Token ' + gTOKEN, // Set the authorization header
    },
    xhrFields: {
      responseType: 'blob', // Set the response type to blob (binary data)
    },
    success: function (data, status, xhr) {
      var blob = data;

      var link = document.createElement('a');
      link.href = URL.createObjectURL(blob);
      link.target = '_blank';
      link.download = 'order_'+ paramStartDate + '-'+ paramEndDate +'.xlsx';

      // Append the link to the DOM and trigger the click event
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    },
    error: function (xhr, status, error) {
      console.error('Error exporting data:', error);
    }
  });
  }

  // Hàm gọi APi để xuất ra danh sách khách hàng theo thứ hạng
  function callApiToExportDataCustomerByRank(paramRank) {
    var url = gBASE_CUSTOMER + "export";
    if(paramRank != "all") {
      url = url + '?rank=' + encodeURIComponent(paramRank);
    }
    $.ajax({
    url: url,
    method: 'GET',
    headers: {
      'Authorization': 'Token ' + gTOKEN,
    },
    xhrFields: {
      responseType: 'blob', 
    },
    success: function (data, status, xhr) {
      var blob = data;

      var link = document.createElement('a');
      link.href = URL.createObjectURL(blob);
      link.target = '_blank';
      link.download = 'customers_' + paramRank +'.xlsx';

      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    },
    error: function (xhr, status, error) {
      console.error('Error exporting data:', error);
    }
  });
  }


  // Hàm format ngày tháng theo kiểu mm/dd/yyyy sang yyyy-mm-dd
  function formatDate(paramDate) {
    let vPartDate = paramDate.split("/");
    let vResultDate = vPartDate[2] + "-" + vPartDate[0] + "-" + vPartDate[1];
    return vResultDate;
  }

  // Hàm lấy ra ngày hiện tại
  function getCurrentDate() {
    var currentDate = new Date();
    var day = currentDate.getDate();
    var month = currentDate.getMonth() + 1; // Note: Months are zero-based
    var year = currentDate.getFullYear();

    // Format the date as "YYYY-MM-DD"
    var formattedDate = year + '-' + (month < 10 ? '0' : '') + month + '-' + (day < 10 ? '0' : '') + day;

    return formattedDate;
  }

  function getCurrentYear() {
    var currentDate = new Date();
    var currentYear = currentDate.getFullYear();
    return currentYear;
  }

  // Hàm gọi API để lấy tổng thu nhập và số đơn hàng
  function callApiToGetTotalPaymentAndNumberOrder() {
    let vHeaders = {
      Authorization: "Token " + gTOKEN
    }
    $.ajax({
      type: "GET",
      url: gBASE + "total",
      headers: vHeaders,
      success: function (paramRes) {
        loadTotalPaymentAndNNumberOrder(paramRes);
      },
      error: function (paramError) {
        console.log(paramError.status);
      }
    });
  }

  // Hàm load dữ liệu tổng đơn hàng và doanh thu vào front end
  function loadTotalPaymentAndNNumberOrder(paramData) {
    let vNumberOrders = paramData[0];
    let vTotalPayment = VND.format(paramData[1]);
    $("#h3-total-payment").html(vTotalPayment);
    $("#h3-number-orders").html(vNumberOrders);
  }

  // Hàm update chart customer
  function updateChartCustomerRank(paramRank, paramSortType) {
    let vTotalCustomer = 0;
    if (paramSortType == "rank-1") {
      let vRankArray = paramRank.map(item => item[0]);
      vRankArray.reverse();
      let vNumberRankArray = paramRank.map(item => item[1]);
      vNumberRankArray.reverse();
      vNumberRankArray.forEach(element => {
        vTotalCustomer += element;
      });
      $("#span-total-customer").html(vTotalCustomer);
      vCustomerChart.data.labels = vRankArray;
      vCustomerChart.data.datasets[0].data = vNumberRankArray;
      vCustomerChart.update();     
    }
    else {
      let vRankArray = paramRank.map(item => item[0]);
      let vNumberRankArray = paramRank.map(item => item[1]);
      vNumberRankArray.forEach(element => {
        vTotalCustomer += element;
      });
      $("#span-total-customer").html(vTotalCustomer);
      vCustomerChart.data.labels = vRankArray;
      vCustomerChart.data.datasets[0].data = vNumberRankArray;
      vCustomerChart.update();
    }
    $("#h3-total-customer").html(vTotalCustomer);
  }

  // Hàm gọi API để load biểu đồ rank của khách hàng
  function callApiToGetCustomerRankReport(paramSortType) {
    let vHeaders = {
      Authorization: "Token " + gTOKEN
    }
    $.ajax({
      type: "GET",
      url: gBASE_CUSTOMER + "rank",
      headers: vHeaders,
      async:false,
      success: function (paramRes) {
        updateChartCustomerRank(paramRes, paramSortType);
      },
      error: function (paramError) {
        console.log(paramError.status);
      }
    });
  }


</script>

</html>